/****************************************************************************
** Interface to the GUI.
**
** Created: Fri Jun 18 22:48:00 2004
**      by: Varol Okan using kate editor
**
**
****************************************************************************/

#ifndef DIALOGCHAPTERS_H
#define DIALOGCHAPTERS_H

#include "uidialogchapters.h"
#include "../sourcefileentry.h"

class MediaInterface;

class DialogChapters : public uiDialogChapters
{
	Q_OBJECT
public:
	 DialogChapters (QWidget * parent, const char * name = 0, WFlags f = 0 );
	~DialogChapters ();

	void initMe(SourceFileInfo *,  const void *);
	void initMe(SourceFileEntry *, const void *);
	SourceFileInfo  *getSourceFileInfo  ();
	SourceFileEntry *getSourceFileEntry ();

private:
	void preview ();
	void play    ();
	void pause   ();

protected slots:
	virtual void slotAddChapter   ();
	virtual void slotDelChapters  ();
	virtual void slotAutoChapters ();
	virtual void slotPreview      ();
	virtual void slotHighlighted  (int);
	virtual void accept ();
	virtual void slotNewPosition(int, const QString &);

private:
	SourceFileInfo  m_sourceFileInfo;
	SourceFileEntry m_sourceFileEntry;
	MediaInterface *m_pMediaInterface;
	QString m_qsPosition;
};

#endif // DIALOGCHAPTERS_H
