#include <qapplication.h>
#include <qvaluelist.h>
#include <qregexp.h>

#include "utils.h"

QValueList <Utils::toolsPaths *> g_listToolsPaths;

QValueList <Utils::toolsPaths *> getToolsPaths ()
{
	Utils::toolsPaths *pEntry = new Utils::toolsPaths;
	pEntry->qsExecutableName = QString("jpeg2yuv");
	pEntry->qsFullPath = QString ("/usr/bin/jpeg2yuv");
	pEntry->bPresent = true;
	g_listToolsPaths.append (pEntry);

	pEntry = new Utils::toolsPaths;
	pEntry->qsExecutableName = QString("spumux");
	pEntry->qsFullPath = QString ("/usr/local/bin/spumux");
	pEntry->bPresent = true;
	g_listToolsPaths.append (pEntry);

	pEntry = new Utils::toolsPaths;
	pEntry->qsExecutableName = QString("dvdauthor");
	pEntry->qsFullPath = QString ("dvdauthor");
	pEntry->bPresent = false;
	g_listToolsPaths.append (pEntry);

	pEntry = new Utils::toolsPaths;
	pEntry->qsExecutableName = QString("mpeg2enc");
	pEntry->qsFullPath = QString ("/usr/local/bin/mpeg2enc");
	pEntry->bPresent = true;
	g_listToolsPaths.append (pEntry);

	return g_listToolsPaths;
}

QString getToolsPath(QString qsCommandLine)
{
	// This function will take the command line as an input and add the full path to each of the tools used in this cmmand line.
	// E.g. 
	// jpeg2yuv -n 50 -I p -f 25 -j "/tmp/Test_colors/Main Menu VMGMbackground.jpg" | mpeg2enc -n p -f 8 -o "/tmp/Test_colors//Main Menu VMGM.m2v"
	// will be converted into 
	// /usr/bin/jpeg2yuv -n 50 -I p -f 25 -j "/tmp/Test_colors/Main Menu VMGMbackground.jpg" | /usr/local/bin/mpeg2enc -n p -f 8 -o "/tmp/Test_colors//Main Menu VMGM.m2v"
	/////////////////////////////////////////////////////////////////////

	uint t;
	QString qsReturn;
	QString qsCommand;
	QRegExp regExp;
	qsReturn = qsCommandLine;
//	QValueList <Utils::toolsPaths *> listToolsPaths = m_pInitObject->getToolsPaths ();
	QValueList <Utils::toolsPaths *> listToolsPaths = getToolsPaths ();
	for (t=0;t<listToolsPaths.count ();t++)	{
//printf ("<%s><%s>\n", (const char *)listToolsPaths[t]->qsExecutableName, (const char *)listToolsPaths[t]->qsFullPath);
//		regExp = QRegExp (QString ("(?!\^)%1 ").arg(listToolsPaths[t]->qsExecutableName));
		if (listToolsPaths[t]->bPresent)	{
 			// The first regExp takes care of all occurances of the tool which do NOT start with a '/'
			regExp = QRegExp ("(^|\\s(?!/+))"+listToolsPaths[t]->qsExecutableName+" ");
			qsReturn.replace (regExp, listToolsPaths[t]->qsFullPath+" ");
			// The second regExp takes care of the case where the user does not leave a blank between the pipe symbol '|' and the tool.
 			regExp = QRegExp ("\\|"+listToolsPaths[t]->qsExecutableName+" ");
			qsReturn.replace (regExp, "| "+listToolsPaths[t]->qsFullPath+" ");
		}
		else
			printf ("WARNING, %s not present in system.\n", (const char *) listToolsPaths[t]->qsExecutableName);
	}
	return qsReturn;
}

int main( int, char ** )
{


    QString qsTest ("jpeg2yuv -n 50 -I p -f 25 -j \"/tmp/Test_spumux/Main Menu VMGMbackground.jpg\" |mpeg2enc -n p -f 8 -o \"/tmp/Test_spumux/Main Menu VMGM.m2v\"");
	
	printf ("<%s>\n", (const char *)qsTest);
	qsTest = getToolsPath (qsTest);
	printf ("<%s>\n", (const char *)qsTest);
    return 0;
}
